import pdb
import atom
import sys
from structure import *
from atom import *

def print_dssp():

    empt_line=" " * 145

if(len(sys.argv)<2):
    print("Not enough arguments! Run with --help to learn more about proper"
          "call structure and parameters.")
else:
    pdb_file = pdb.PDBFile(sys.argv[1])
  
    #turns = get_turns(pdb_file.residues)
    #get_helix(pdb_file.residues, turns)
    #get_bends(pdb_file.residues)
    # get_chirality(pdb_file.residues)


    # print("NBRIDGES",len(bridges))

    # bridges = get_bridges(pdb_file.residues)

    # get_bonds(pdb_file.residues)


    # e_min = 0
    # for res in residues:
    #     ene = residues[1].h_bond(res)
    #     if ene <= e_min:
    #         e_min = ene
    #         best_res = res
    #print(residues[1].resid, best_res.resid,e_min)

    #get_phi_psi(residues)
    #print(residues[2].atoms, residues[0].resid, residues[1].resid)
    #print(get_TCO(residues[2],residues[3]))


# for i,ladder in enumerate(ladders.values()):
#     print(chr(65+i))
    
# for ind, sheet in sheets.items():
#     print(ind, sheet)
#     for ladder in sheet:
#         print(ladder['start'], ladder['end'])


################### OUTPUT ####################
# print DSSP-style formatted header of PDB file
for elem in pdb_file.get_header() : 
    print(pdb_file.get_header()[elem], end="")

# Get preliminary data for print loop
residues = pdb_file.residues
bridges = get_bridges(residues)
ladders = get_ladders(bridges, residues)
sheets = get_sheets(ladders)  

# iterating over residues
for i,res in enumerate(residues):
    #res.get_turns(residues, turns)
    #res.get_helix(residues)
    kappa = res.get_bends(residues)
    t_co = res.get_tco(residues)
    alpha = res.get_chirality(residues)[0]
    phi = res.get_phi_psi(residues)[0]
    psi = res.get_phi_psi(residues)[1]
    x_ca = res.atoms["CA"].coord_x
    y_ca = res.atoms["CA"].coord_y
    z_ca = res.atoms["CA"].coord_z
    print(i+1, res.resid, res.chain_id, res.res_letter, round(t_co, 3), round(kappa,1),
          round(alpha, 1), round(phi, 1), round(psi,1), round(x_ca,1), round(y_ca,1), round(z_ca,1))
